Index: trunk/source/processes/electromagnetic/standard/src/G4PAIySection.cc
===================================================================
--- trunk/source/processes/electromagnetic/standard/src/G4PAIySection.cc	(revision 1058)
+++ trunk/source/processes/electromagnetic/standard/src/G4PAIySection.cc	(revision 1196)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4PAIySection.cc,v 1.3 2007/10/01 18:38:10 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-02 $
+// $Id: G4PAIySection.cc,v 1.4 2009/07/26 15:51:01 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 // 
@@ -41,4 +41,6 @@
 //
 // 01.10.07, V.Ivanchenko create using V.Grichine G4PAIxSection class
+// 26.07.09, V.Ivanchenko added protection for mumerical exceptions for 
+//              low-density materials
 //
 
@@ -128,10 +130,6 @@
 	// G4cout<<fEnergyInterval[i]<<"\t"<<fA1[i]<<"\t"<<fA2[i]<<"\t"
 	//   <<fA3[i]<<"\t"<<fA4[i]<<"\t"<<G4endl ;
-        if(fEnergyInterval[i+1]-fEnergyInterval[i] >
+        if(fEnergyInterval[i+1]-fEnergyInterval[i] <
            1.5*fDelta*(fEnergyInterval[i+1]+fEnergyInterval[i]))
-	  {
-	    continue ;
-	  }
-        else
 	  {
 	    for(j=i;j<fIntervalNumber;j++)
@@ -529,5 +527,6 @@
    //  result *= (1-exp(-be2/betaBohr2)) ;
    result *= (1-exp(-be4/betaBohr4)) ;
-   if(fDensity >= 0.1)
+   //   if(fDensity >= 0.1)
+   if(x8 > 0.)
    { 
       result /= x8 ;
@@ -586,10 +585,12 @@
    dNdxC *= (1-exp(-be4/betaBohr4)) ;
 
-   if(fDensity >= 0.1)
-   { 
-      modul2 = (1.0 + fRePartDielectricConst[i])*(1.0 + fRePartDielectricConst[i]) + 
+   //   if(fDensity >= 0.1)
+   // { 
+   modul2 = (1.0 + fRePartDielectricConst[i])*(1.0 + fRePartDielectricConst[i]) + 
                     fImPartDielectricConst[i]*fImPartDielectricConst[i] ;
-      dNdxC /= modul2 ;
-   }
+   if(modul2 > 0.)
+     {
+       dNdxC /= modul2 ;
+     }
    return dNdxC ;
 
@@ -626,10 +627,12 @@
    dNdxP *= (1-exp(-be4/betaBohr4)) ;
 
-   if( fDensity >= 0.1 )
-   { 
-     modul2 = (1 + fRePartDielectricConst[i])*(1 + fRePartDielectricConst[i]) + 
-        fImPartDielectricConst[i]*fImPartDielectricConst[i] ;
-     dNdxP /= modul2 ;
-   }
+//   if( fDensity >= 0.1 )
+//   { 
+   modul2 = (1 + fRePartDielectricConst[i])*(1 + fRePartDielectricConst[i]) + 
+     fImPartDielectricConst[i]*fImPartDielectricConst[i] ;
+   if(modul2 > 0.)
+     { 
+       dNdxP /= modul2 ;
+     }
    return dNdxP ;
 
@@ -800,5 +803,5 @@
 G4double G4PAIySection::SumOverInterCerenkov( G4int i )
 {         
-   G4double x0,x1,y0,yy1,a,b,c,result ;
+   G4double x0,x1,y0,yy1,a,c,result ;
 
    x0  = fSplineEnergy[i] ;
@@ -811,5 +814,6 @@
    c = x1/x0;
    a = log10(yy1/y0)/log10(c) ;
-   b = y0/pow(x0,a) ;
+   G4double b = 0.0;
+   if(a < 20.) b = y0/pow(x0,a) ;
 
    a += 1.0 ;
@@ -833,5 +837,5 @@
 G4double G4PAIySection::SumOverInterPlasmon( G4int i )
 {         
-   G4double x0,x1,y0,yy1,a,b,c,result ;
+   G4double x0,x1,y0,yy1,a,c,result ;
 
    x0  = fSplineEnergy[i] ;
@@ -841,6 +845,7 @@
    c =x1/x0;
    a = log10(yy1/y0)/log10(c) ;
-   // b = log10(y0) - a*log10(x0) ;
-   b = y0/pow(x0,a) ;
+
+   G4double b = 0.0;
+   if(a < 20.) b = y0/pow(x0,a) ;
 
    a += 1.0 ;
@@ -864,5 +869,5 @@
                                        G4double en0    )
 {               
-   G4double x0,x1,y0,yy1,a,b,c,d,e0,result ;
+   G4double x0,x1,y0,yy1,a,c,d,e0,result ;
 
    e0 = en0 ;
@@ -875,6 +880,7 @@
    d = e0/x0;   
    a = log10(yy1/y0)/log10(x1/x0) ;
-   // b0 = log10(y0) - a*log10(x0) ;
-   b = y0/pow(x0,a);  // pow(10.,b) ;
+
+   G4double b = 0.0;
+   if(a < 20.) b = y0/pow(x0,a) ;
    
    a += 1 ;
@@ -933,5 +939,5 @@
                                        G4double en0    )
 {               
-   G4double x0,x1,y0,yy1,a,b,c,d,e0,result ;
+   G4double x0,x1,y0,yy1,a,c,d,e0,result ;
 
    e0 = en0 ;
@@ -944,6 +950,7 @@
    d = e0/x0;   
    a = log10(yy1/y0)/log10(x1/x0) ;
-   // b0 = log10(y0) - a*log10(x0) ;
-   b = y0/pow(x0,a);  // pow(10.,b) ;
+   
+   G4double b = 0.0;
+   if(a < 20.) b = y0/pow(x0,a) ;
    
    a += 2 ;
@@ -964,6 +971,7 @@
    d = e0/x0;   
    a = log10(yy1/y0)/log10(x1/x0) ;
-   //  b0 = log10(y0) - a*log10(x0) ;
-   b = y0/pow(x0,a) ;
+
+   if(a < 20.) b = y0/pow(x0,a) ;
+
    a += 2 ;
    if(a == 0) 
@@ -987,5 +995,5 @@
                                              G4double en0    )
 {               
-   G4double x0,x1,y0,yy1,a,b,e0,c,d,result ;
+   G4double x0,x1,y0,yy1,a,e0,c,d,result ;
 
    e0 = en0 ;
@@ -996,11 +1004,12 @@
 
    //  G4cout<<G4endl;
-   //  G4cout<<"SumBordC, i = "<<i<<"; en0 = "<<en0<<"; x0 ="<<x0<<"; x1 = "<<x1
+   //G4cout<<"SumBordC, i = "<<i<<"; en0 = "<<en0<<"; x0 ="<<x0<<"; x1 = "<<x1
    //     <<"; y0 = "<<y0<<"; yy1 = "<<yy1<<G4endl;
    c = x1/x0 ;
    d = e0/x0 ;
    a = log10(yy1/y0)/log10(c) ;
-   // b0 = log10(y0) - a*log10(x0) ;
-   b = y0/pow(x0,a); // pow(10.,b0) ;   
+ 
+   G4double b = 0.0;
+   if(a < 20.) b = y0/pow(x0,a) ;
    
    a += 1.0 ;
@@ -1012,5 +1021,5 @@
    else         fIntegralCerenkov[0] += y0*(x0*x0 - e0*e0*pow(d,a-2))/a ;
 
-// G4cout<<"a = "<<a<<"; b0 = "<<b0<<"; b = "<<b<<"; result = "<<result<<G4endl;
+   //G4cout<<"a = "<<a<<"; b = "<<b<<"; result = "<<result<<G4endl;
    
    x0  = fSplineEnergy[i - 1] ;
@@ -1019,5 +1028,5 @@
    yy1 = fdNdxCerenkov[i - 2] ;
 
-   // G4cout<<"x0 ="<<x0<<"; x1 = "<<x1
+   //G4cout<<"x0 ="<<x0<<"; x1 = "<<x1
    //    <<"; y0 = "<<y0<<"; yy1 = "<<yy1<<G4endl;
 
@@ -1025,6 +1034,12 @@
    d = e0/x0 ;
    a  = log10(yy1/y0)/log10(x1/x0) ;
-   // b0 = log10(y0) - a*log10(x0) ;
-   b  =  y0/pow(x0,a);  // pow(10.,b0) ;
+  
+   //   G4cout << "a= " << a << G4endl;
+   if(a < 20.) b = y0/pow(x0,a) ;
+
+   if(a > 20.0) b = 0.0;
+   else         b = y0/pow(x0,a);  // pow(10.,b0) ;
+
+   //G4cout << "b= " << b << G4endl;
 
    a += 1.0 ;
@@ -1032,10 +1047,10 @@
    else         result += y0*(e0*pow(d,a-1) - x0 )/a ;
    a += 1.0 ;
+   //G4cout << "result= " << result << G4endl;
 
    if( a == 0 )   fIntegralCerenkov[0] += b*log(e0/x0) ;
    else           fIntegralCerenkov[0] += y0*(e0*e0*pow(d,a-2) - x0*x0)/a ;
 
-   // G4cout<<"a = "<<a<<"; b0 = "<<b0<<"; b = "
-   // <<b<<"; result = "<<result<<G4endl;    
+   //G4cout<<"a = "<<a<<"; b = "<<b<<"; result = "<<result<<G4endl;    
 
    return result ;
@@ -1051,5 +1066,5 @@
                                              G4double en0    )
 {               
-   G4double x0,x1,y0,yy1,a,b,c,d,e0,result ;
+   G4double x0,x1,y0,yy1,a,c,d,e0,result ;
 
    e0 = en0 ;
@@ -1062,6 +1077,7 @@
    d = e0/x0 ;   
    a = log10(yy1/y0)/log10(c) ;
-   //  b0 = log10(y0) - a*log10(x0) ;
-   b = y0/pow(x0,a); //pow(10.,b) ;
+
+   G4double b = 0.0;
+   if(a < 20.) b = y0/pow(x0,a) ;
    
    a += 1.0 ;
@@ -1081,6 +1097,6 @@
    d = e0/x0 ;
    a = log10(yy1/y0)/log10(c) ;
-   // b0 = log10(y0) - a*log10(x0) ;
-   b = y0/pow(x0,a);// pow(10.,b0) ;
+ 
+   if(a < 20.) b = y0/pow(x0,a) ;
 
    a += 1.0 ;
Index: trunk/source/processes/electromagnetic/standard/src/G4PEEffectModel.cc
===================================================================
--- trunk/source/processes/electromagnetic/standard/src/G4PEEffectModel.cc	(revision 1058)
+++ trunk/source/processes/electromagnetic/standard/src/G4PEEffectModel.cc	(revision 1196)
@@ -25,5 +25,5 @@
 //
 // $Id: G4PEEffectModel.cc,v 1.8 2009/04/09 18:41:18 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 // -------------------------------------------------------------------
Index: trunk/source/processes/electromagnetic/standard/src/G4PSTARStopping.cc
===================================================================
--- trunk/source/processes/electromagnetic/standard/src/G4PSTARStopping.cc	(revision 1058)
+++ trunk/source/processes/electromagnetic/standard/src/G4PSTARStopping.cc	(revision 1196)
@@ -25,5 +25,5 @@
 //
 // $Id: G4PSTARStopping.cc,v 1.8 2008/11/24 18:28:09 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-02 $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 
 //---------------------------------------------------------------------------
Index: trunk/source/processes/electromagnetic/standard/src/G4PairProductionRelModel.cc
===================================================================
--- trunk/source/processes/electromagnetic/standard/src/G4PairProductionRelModel.cc	(revision 1058)
+++ trunk/source/processes/electromagnetic/standard/src/G4PairProductionRelModel.cc	(revision 1196)
@@ -25,5 +25,5 @@
 //
 // $Id: G4PairProductionRelModel.cc,v 1.3 2009/05/15 17:12:33 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 // -------------------------------------------------------------------
Index: trunk/source/processes/electromagnetic/standard/src/G4PhotoElectricEffect.cc
===================================================================
--- trunk/source/processes/electromagnetic/standard/src/G4PhotoElectricEffect.cc	(revision 1058)
+++ trunk/source/processes/electromagnetic/standard/src/G4PhotoElectricEffect.cc	(revision 1196)
@@ -25,5 +25,5 @@
 //
 // $Id: G4PhotoElectricEffect.cc,v 1.42 2009/02/20 12:06:37 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 //
Index: trunk/source/processes/electromagnetic/standard/src/G4PolarizedComptonScattering.cc
===================================================================
--- trunk/source/processes/electromagnetic/standard/src/G4PolarizedComptonScattering.cc	(revision 1058)
+++ trunk/source/processes/electromagnetic/standard/src/G4PolarizedComptonScattering.cc	(revision 1196)
@@ -26,5 +26,5 @@
 //
 // $Id: G4PolarizedComptonScattering.cc,v 1.18 2008/10/15 17:53:44 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-02 $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 //
Index: trunk/source/processes/electromagnetic/standard/src/G4UniversalFluctuation.cc
===================================================================
--- trunk/source/processes/electromagnetic/standard/src/G4UniversalFluctuation.cc	(revision 1058)
+++ trunk/source/processes/electromagnetic/standard/src/G4UniversalFluctuation.cc	(revision 1196)
@@ -25,5 +25,5 @@
 //
 // $Id: G4UniversalFluctuation.cc,v 1.22 2009/03/20 18:11:23 urban Exp $
-// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 // -------------------------------------------------------------------
Index: trunk/source/processes/electromagnetic/standard/src/G4UrbanMscModel.cc
===================================================================
--- trunk/source/processes/electromagnetic/standard/src/G4UrbanMscModel.cc	(revision 1058)
+++ trunk/source/processes/electromagnetic/standard/src/G4UrbanMscModel.cc	(revision 1196)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4UrbanMscModel.cc,v 1.90 2009/04/29 13:30:22 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
+// $Id: G4UrbanMscModel.cc,v 1.91 2009/07/20 18:41:34 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 // -------------------------------------------------------------------
@@ -122,5 +122,5 @@
   lambdalimit   = 1.*mm;
   fr            = 0.02;
-  facsafety     = 0.3;
+  //  facsafety     = 0.3;
   taubig        = 8.0;
   tausmall      = 1.e-16;
Index: trunk/source/processes/electromagnetic/standard/src/G4UrbanMscModel2.cc
===================================================================
--- trunk/source/processes/electromagnetic/standard/src/G4UrbanMscModel2.cc	(revision 1058)
+++ trunk/source/processes/electromagnetic/standard/src/G4UrbanMscModel2.cc	(revision 1196)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4UrbanMscModel2.cc,v 1.26 2009/05/19 06:26:10 urban Exp $
-// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
+// $Id: G4UrbanMscModel2.cc,v 1.27 2009/07/20 18:41:34 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 // -------------------------------------------------------------------
@@ -119,5 +119,5 @@
   lambdalimit   = 1.*mm;
   fr            = 0.02;
-  facsafety     = 0.3;
+  //facsafety     = 0.3;
   taubig        = 8.0;
   tausmall      = 1.e-16;
@@ -462,7 +462,8 @@
   presafety = sp->GetSafety();
 
-  //    G4cout << "G4UrbanMscModel2::ComputeTruePathLengthLimit tPathLength= " 
-  //	   <<tPathLength<<" safety= " << presafety
-  //	   << " range= " <<currentRange<<G4endl;
+  //G4cout << "G4Urban2::StepLimit tPathLength= " 
+  //	 <<tPathLength<<" safety= " << presafety
+  //       << " range= " <<currentRange<< " lambda= "<<lambda0
+  //	 << " Alg: " << steppingAlgorithm <<G4endl;
 
   // far from geometry boundary
@@ -506,5 +507,6 @@
           tlimitmin = 10.*stepmin;
           if(tlimitmin < tlimitminfix) tlimitmin = tlimitminfix;
-
+	  //G4cout << "rangeinit= " << rangeinit << " stepmin= " << stepmin
+	  //	 << " tlimitmin= " << tlimitmin << " geomlimit= " << geomlimit <<G4endl;
           // constraint from the geometry
           if((geomlimit < geombig) && (geomlimit > geommin))
@@ -535,6 +537,6 @@
       if(tlimit > tgeom) tlimit = tgeom;
 
-      //  G4cout << "tgeom= " << tgeom << " geomlimit= " << geomlimit  
-      //     << " tlimit= " << tlimit << " presafety= " << presafety << G4endl;
+      //G4cout << "tgeom= " << tgeom << " geomlimit= " << geomlimit  
+      //      << " tlimit= " << tlimit << " presafety= " << presafety << G4endl;
 
       // shortcut
@@ -627,5 +629,5 @@
 	}
     }
-  // G4cout << "tPathLength= " << tPathLength << "  geomlimit= " << geomlimit 
+  //G4cout << "tPathLength= " << tPathLength 
   //	 << " currentMinimalStep= " << currentMinimalStep << G4endl;
   return tPathLength ;
@@ -713,5 +715,5 @@
 
   if(zPathLength > lambda0) zPathLength = lambda0;
-
+  //G4cout << "zPathLength= " << zPathLength << " lambda1= " << lambda0 << G4endl;
   return zPathLength;
 }
@@ -744,4 +746,5 @@
   }
   if(tPathLength < geomStepLength) tPathLength = geomStepLength;
+  //G4cout << "tPathLength= " << tPathLength << " step= " << geomStepLength << G4endl;
 
   return tPathLength;
@@ -799,5 +802,5 @@
 
     G4double r = SampleDisplacement();
-    /*
+    /*    
     G4cout << "G4UrbanMscModel2::SampleSecondaries: e(MeV)= " << kineticEnergy
 	   << " sinTheta= " << sth << " r(mm)= " << r
Index: trunk/source/processes/electromagnetic/standard/src/G4UrbanMscModel90.cc
===================================================================
--- trunk/source/processes/electromagnetic/standard/src/G4UrbanMscModel90.cc	(revision 1058)
+++ trunk/source/processes/electromagnetic/standard/src/G4UrbanMscModel90.cc	(revision 1196)
@@ -25,5 +25,5 @@
 //
 // $Id: G4UrbanMscModel90.cc,v 1.13 2009/04/10 18:10:58 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 // -------------------------------------------------------------------
Index: trunk/source/processes/electromagnetic/standard/src/G4WaterStopping.cc
===================================================================
--- trunk/source/processes/electromagnetic/standard/src/G4WaterStopping.cc	(revision 1058)
+++ trunk/source/processes/electromagnetic/standard/src/G4WaterStopping.cc	(revision 1196)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: G4WaterStopping.cc,v 1.16 2009/05/15 19:04:21 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
+// $Id: G4WaterStopping.cc,v 1.18 2009/06/19 10:39:48 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 
 //---------------------------------------------------------------------------
@@ -67,5 +67,5 @@
 {
   G4double res = 0.0;
-  if(iz < 3 || iz > 18) return res; 
+  if((iz > 26) || (iz < 3) || (iz > 18 && iz < 26)) return res; 
   G4bool b;
   G4int idx = iz - 3;
@@ -99,8 +99,8 @@
   G4int i;
   //..List of ions
-  G4int zz[16] = {3, 4, 5, 6, 7, 8, 9, 10,11,12,13,14,15,16,17,18};
-  G4int aa[16] = {7, 9, 11, 12, 14, 16, 19, 20, 23, 24, 27, 28,31,32, 35,40};
-  // G4double A_Ion[17] = {6.941,9.0122,10.811,12.011,14.007,15.999,18.998,20.180,22.990,24.305,26.982,28.086,30.974,32.065,35.453,39.948};
-  for(i=0; i<16; i++) {
+  G4int zz[17] = {3, 4, 5, 6, 7, 8, 9, 10,11,12,13,14,15,16,17,18,26};
+  G4int aa[17] = {7, 9, 11, 12, 14, 16, 19, 20, 23, 24, 27, 28,31,32, 35,40,56};
+  // G4double A_Ion[17] = {6.941,9.0122,10.811,12.011,14.007,15.999,18.998,20.180,22.990,24.305,26.982,28.086,30.974,32.065,35.453,39.948,55.845};
+  for(i=0; i<17; i++) {
     Z[i] = zz[i];
     A[i] = G4double(aa[i]);
@@ -145,6 +145,9 @@
   AddData(E,G4_WATER_Ar,factor);
 
+  G4double G4_WATER_Fe [53]={6.5394, 7.3060, 8.7367, 10.0690, 11.3310, 12.5470, 13.7280, 14.8780, 15.9980, 21.1160, 25.4850, 29.1260, 32.0640, 36.1770, 38.6920, 40.2760, 41.2950, 41.9530, 42.3710, 42.6210, 42.5910, 41.6900, 40.5190, 39.2690, 36.8000, 34.5040, 32.4190, 30.5410, 28.8480, 27.3170, 25.9310, 20.6170, 17.0680, 14.5540, 12.6930, 10.1410, 8.4892, 7.3402, 6.4976, 5.8545, 5.3479, 4.9387, 3.6892, 3.0503, 2.6620, 2.4014, 2.0756, 1.8825, 1.7569, 1.6702, 1.6079, 1.5619, 1.5267};
+  AddData(E,G4_WATER_Fe,factor);
+
   if(corr) {
-    for(i=0; i<16; i++) {corr->AddStoppingData(Z[i], aa[i], "G4_WATER", dedx[i]);}
+    for(i=0; i<17; i++) {corr->AddStoppingData(Z[i], aa[i], "G4_WATER", dedx[i]);}
   }
 }
Index: trunk/source/processes/electromagnetic/standard/src/G4WentzelVIModel.cc
===================================================================
--- trunk/source/processes/electromagnetic/standard/src/G4WentzelVIModel.cc	(revision 1058)
+++ trunk/source/processes/electromagnetic/standard/src/G4WentzelVIModel.cc	(revision 1196)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: G4WentzelVIModel.cc,v 1.32 2009/05/10 16:09:29 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
+// $Id: G4WentzelVIModel.cc,v 1.37 2009/10/28 10:14:13 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 // -------------------------------------------------------------------
@@ -135,5 +135,5 @@
   // reset parameters
   SetupParticle(p);
-  tkin = targetZ = mom2 = DBL_MIN;
+  tkin = targetZ = mom2 = 0.0;
   ecut = etag = DBL_MAX;
   currentRange = 0.0;
@@ -158,9 +158,9 @@
 {
   SetupParticle(p);
-  G4double ekin = std::max(lowEnergyLimit, kinEnergy);
-  SetupKinematic(ekin, cutEnergy);
-  SetupTarget(Z, ekin);
+  if(kinEnergy < lowEnergyLimit) return 0.0;
+  SetupKinematic(kinEnergy, cutEnergy);
+  SetupTarget(Z, kinEnergy);
   G4double xsec = ComputeTransportXSectionPerAtom();
-  /*  
+  /*   
   G4cout << "CS: e= " << tkin << " cosEl= " << cosTetMaxElec2 
 	 << " cosN= " << cosTetMaxNuc2 << " xsec(bn)= " << xsec/barn
@@ -392,5 +392,7 @@
   //	 << particle->GetParticleName() << G4endl;
   G4double kinEnergy = dynParticle->GetKineticEnergy();
-  if(kinEnergy <= DBL_MIN || tPathLength <= DBL_MIN) return;
+
+  // ignore scattering for zero step length and enegy below the limit
+  if(kinEnergy < lowEnergyLimit || tPathLength <= DBL_MIN) return;
 
   G4double ekin = preKinEnergy;
@@ -423,5 +425,4 @@
 
     // for low-energy e-,e+ no limit
-    ekin = std::max(ekin, lowEnergyLimit);
     SetupKinematic(ekin, cut);
   
@@ -431,6 +432,6 @@
       xsec = ComputeXSectionPerVolume();
 
-      if(xtsec > DBL_MIN) x1 = 0.5*tPathLength*xtsec;
-      else                x1 = 0.0;
+      if(xtsec > 0.0) x1 = 0.5*tPathLength*xtsec;
+      else            x1 = 0.0;
 
       /*      
@@ -452,6 +453,6 @@
   // cost is sampled ------------------------------
   G4double cost = 1.0 - 2.0*z;
-  if(cost < -1.0) cost = -1.0;
-  else if(cost > 1.0) cost = 1.0;
+  //  if(cost < -1.0) cost = -1.0;
+  // else if(cost > 1.0) cost = 1.0;
   G4double sint = sqrt((1.0 - cost)*(1.0 + cost));
 
@@ -472,5 +473,5 @@
 
   // sample MSC scattering for large angle
-  // extra central scattering for holf step
+  // extra central scattering for half step
   if(largeAng) {
     isscat = true;
@@ -480,5 +481,5 @@
     } while (z > 1.0); 
     cost = 1.0 - 2.0*z;
-    if(std::abs(cost) > 1.0) cost = 1.0;
+    //if(std::fabs(cost) > 1.0) cost = 1.0;
 
     sint = sqrt((1.0 - cost)*(1.0 + cost));
@@ -491,5 +492,5 @@
   }
 
-  // sample Reserford scattering for large angle
+  // sample Rutherford scattering for large angle
   if(xsec > DBL_MIN) {
     G4double t = tPathLength;
@@ -536,5 +537,5 @@
         if(zz1 < 1.0) {
 	  isscat = true;
-	  //G4cout << "Reserford zz1= " << zz1 << " t= " << t << G4endl;
+	  //G4cout << "Rutherford zz1= " << zz1 << " t= " << t << G4endl;
 	  sint = sqrt((1.0 - zz1)*(1.0 + zz1));
 	  //G4cout << "sint= " << sint << G4endl;
@@ -637,5 +638,5 @@
     if(cosThetaMin > cosnm) {
 
-      // Reserford part
+      // Rutherford part
       G4double s  = screenZ*formfactA;
       G4double z1 = 1.0 - cosnm + screenZ;
@@ -711,5 +712,5 @@
       zcorr  += 0.5*x*s;
 
-      // Reserford part
+      // Rutherford part
       G4double z1 = 1.0 - cosTetMaxElec + screenZ;
       G4double z2 = (cosThetaMin - cosTetMaxElec)/x1; 
@@ -730,5 +731,5 @@
       zcorr  += 0.5*x*s;
 
-      // Reserford part
+      // Rutherford part
       s  = screenZ*formfactA;
       G4double w  = 1.0 + 2.0*s;
Index: trunk/source/processes/electromagnetic/standard/src/G4eBremsstrahlung.cc
===================================================================
--- trunk/source/processes/electromagnetic/standard/src/G4eBremsstrahlung.cc	(revision 1058)
+++ trunk/source/processes/electromagnetic/standard/src/G4eBremsstrahlung.cc	(revision 1196)
@@ -25,5 +25,5 @@
 //
 // $Id: G4eBremsstrahlung.cc,v 1.56 2009/02/20 12:06:37 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 // -------------------------------------------------------------------
Index: trunk/source/processes/electromagnetic/standard/src/G4eBremsstrahlungModel.cc
===================================================================
--- trunk/source/processes/electromagnetic/standard/src/G4eBremsstrahlungModel.cc	(revision 1058)
+++ trunk/source/processes/electromagnetic/standard/src/G4eBremsstrahlungModel.cc	(revision 1196)
@@ -25,5 +25,5 @@
 //
 // $Id: G4eBremsstrahlungModel.cc,v 1.44 2009/04/09 18:41:18 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 // -------------------------------------------------------------------
Index: trunk/source/processes/electromagnetic/standard/src/G4eBremsstrahlungRelModel.cc
===================================================================
--- trunk/source/processes/electromagnetic/standard/src/G4eBremsstrahlungRelModel.cc	(revision 1058)
+++ trunk/source/processes/electromagnetic/standard/src/G4eBremsstrahlungRelModel.cc	(revision 1196)
@@ -25,5 +25,5 @@
 //
 // $Id: G4eBremsstrahlungRelModel.cc,v 1.14 2009/04/09 18:41:18 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 // -------------------------------------------------------------------
Index: trunk/source/processes/electromagnetic/standard/src/G4eCoulombScatteringModel.cc
===================================================================
--- trunk/source/processes/electromagnetic/standard/src/G4eCoulombScatteringModel.cc	(revision 1058)
+++ trunk/source/processes/electromagnetic/standard/src/G4eCoulombScatteringModel.cc	(revision 1196)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: G4eCoulombScatteringModel.cc,v 1.69 2009/05/10 16:09:29 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
+// $Id: G4eCoulombScatteringModel.cc,v 1.78 2009/10/28 10:14:13 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 // -------------------------------------------------------------------
@@ -39,4 +39,5 @@
 //
 // Modifications:
+//
 // 01.08.06 V.Ivanchenko extend upper limit of table to TeV and review the
 //          logic of building - only elements from G4ElementTable
@@ -45,4 +46,6 @@
 // 09.10.07 V.Ivanchenko reorganized methods, add cut dependence in scattering off e- 
 // 09.06.08 V.Ivanchenko add SelectIsotope and sampling of the recoil ion 
+// 16.06.09 C.Consolandi fixed computation of effective mass
+//
 //
 // Class Description:
@@ -63,4 +66,6 @@
 #include "G4Proton.hh"
 #include "G4ParticleTable.hh"
+#include "G4ProductionCutsTable.hh"
+#include "G4NucleiProperties.hh"
 
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
@@ -87,10 +92,10 @@
   currentMaterial = 0; 
   currentElement  = 0;
-  lowEnergyLimit = keV;
+  lowEnergyLimit  = 0.1*keV;
   G4double p0 = electron_mass_c2*classic_electr_radius;
   coeff  = twopi*p0*p0;
   tkin = targetZ = mom2 = DBL_MIN;
   elecXSection = nucXSection = 0.0;
-  recoilThreshold = 100.*keV;
+  recoilThreshold = 0.*keV;
   ecut = DBL_MAX;
   particle = 0;
@@ -130,8 +135,9 @@
   ecut = etag = DBL_MAX;
   cosThetaMin = cos(PolarAngleLimit());
-  currentCuts = &cuts;
+  pCuts = G4ProductionCutsTable::GetProductionCutsTable()->GetEnergyCutsVector(3);
   //G4cout << "!!! G4eCoulombScatteringModel::Initialise for " 
   //	 << p->GetParticleName() << "  cos(TetMin)= " << cosThetaMin 
   //	 << "  cos(TetMax)= " << cosThetaMax <<G4endl;
+  // G4cout << "cut0= " << cuts[0] << "  cut1= " << cuts[1] << G4endl;
   if(!isInitialised) {
     isInitialised = true;
@@ -185,8 +191,8 @@
   G4double xsec = 0.0;
   SetupParticle(p);
-  G4double ekin = std::max(lowEnergyLimit, kinEnergy);
-  SetupKinematic(ekin, cutEnergy);
+  if(kinEnergy < lowEnergyLimit) return xsec;
+  SetupKinematic(kinEnergy, cutEnergy);
   if(cosTetMaxNuc < cosTetMinNuc) {
-    SetupTarget(Z, ekin);
+    SetupTarget(Z, kinEnergy);
     xsec = CrossSectionPerAtom();  
   }
@@ -196,6 +202,5 @@
 	 << " cosTetMaxElec= " << cosTetMaxElec
 	 << " screenZ= " << screenZ
-	 << " formfactA= " << formfactA
-	 << " cosTetMaxHad= " << cosTetMaxHad << G4endl;
+	 << " formfactA= " << formfactA << G4endl;
   */
   return xsec;  
@@ -207,5 +212,9 @@
 {
   // This method needs initialisation before be called
-  G4double fac = coeff*targetZ*chargeSquare*kinFactor;
+  //G4double fac = coeff*targetZ*chargeSquare*invbeta2/mom2;
+
+  G4double meff = targetMass/(mass+targetMass);
+  G4double fac  = coeff*targetZ*chargeSquare*invbeta2/(mom2*meff*meff);
+
   elecXSection = 0.0;
   nucXSection  = 0.0;
@@ -257,16 +266,21 @@
 {
   G4double kinEnergy = dp->GetKineticEnergy();
-  if(kinEnergy <= DBL_MIN) return;
+  if(kinEnergy < lowEnergyLimit) return;
   DefineMaterial(couple);
   SetupParticle(dp->GetDefinition());
-  G4double ekin = std::max(lowEnergyLimit, kinEnergy);
-  SetupKinematic(ekin, cutEnergy);
+
+  SetupKinematic(kinEnergy, cutEnergy);
   //G4cout << "G4eCoulombScatteringModel::SampleSecondaries e(MeV)= " 
-  //	 << kinEnergy << "  " << particle->GetParticleName() << G4endl;
+  //	 << kinEnergy << "  " << particle->GetParticleName() 
+  //	 << " cut= " << cutEnergy<< G4endl;
  
   // Choose nucleus
-  currentElement = SelectRandomAtom(couple,particle,ekin,cutEnergy,ekin);
-
-  SetupTarget(currentElement->GetZ(),ekin);
+  currentElement = SelectRandomAtom(couple,particle,
+				    kinEnergy,cutEnergy,kinEnergy);
+
+  SetupTarget(currentElement->GetZ(),kinEnergy);
+
+  G4int ia = SelectIsotopeNumber(currentElement);
+  targetMass = G4NucleiProperties::GetNuclearMass(ia, iz);
   
   G4double cost = SampleCosineTheta();
@@ -276,5 +290,5 @@
   G4double sint = sqrt(z1*(1.0 + cost));
   
-  //G4cout<<"## Sampled sint= " << sint << "  Z= " << targetZ 
+  //G4cout<<"## Sampled sint= " << sint << "  Z= " << targetZ << " A= " << ia
   //	<< "  screenZ= " << screenZ << " cn= " << formfactA << G4endl;
   
@@ -289,18 +303,26 @@
   // recoil sampling assuming a small recoil
   // and first order correction to primary 4-momentum
-  if(lowEnergyLimit < kinEnergy) {
-    G4int ia = SelectIsotopeNumber(currentElement);
-    G4double Trec = z1*mom2/(amu_c2*G4double(ia));
-
-    if(Trec > recoilThreshold) {
-      G4ParticleDefinition* ion = theParticleTable->FindIon(iz, ia, 0, iz);
-      Trec = z1*mom2/ion->GetPDGMass();
-      if(Trec < kinEnergy) {
-	G4ThreeVector dir = (direction - newDirection).unit();
-	G4DynamicParticle* newdp = new G4DynamicParticle(ion, dir, Trec);
-	fvect->push_back(newdp);
-	fParticleChange->SetProposedKineticEnergy(kinEnergy - Trec);
-      }
-    }
+  G4double q2   = 2*z1*mom2;
+  G4double trec = q2/(sqrt(targetMass*targetMass + q2) + targetMass);
+  G4double finalT = kinEnergy - trec; 
+  //G4cout<<"G4eCoulombScatteringModel: finalT= "<<finalT<<" Trec= "<<trec<<G4endl;
+  if(finalT <= lowEnergyLimit) { 
+    trec = kinEnergy;  
+    finalT = 0.0;
+  } 
+
+  fParticleChange->SetProposedKineticEnergy(finalT);
+  G4double tcut = recoilThreshold;
+  if(pCuts) { tcut= std::max(tcut,(*pCuts)[currentMaterialIndex]); }
+
+  if(trec > tcut) {
+    G4ParticleDefinition* ion = theParticleTable->FindIon(iz, ia, 0, iz);
+    G4ThreeVector dir = (direction*sqrt(mom2) - 
+			 newDirection*sqrt(finalT*(2*mass + finalT))).unit();
+    G4DynamicParticle* newdp = new G4DynamicParticle(ion, dir, trec);
+    fvect->push_back(newdp);
+  } else {
+    fParticleChange->ProposeLocalEnergyDeposit(trec);
+    fParticleChange->ProposeNonIonizingEnergyDeposit(trec);
   }
  
@@ -324,12 +346,12 @@
   }
 
-  /*
+  /*  
   G4cout << "SampleCost: e(MeV)= " << tkin 
-  	 << " ctmin= " << cosThetaMin
-  	 << " ctmaxN= " << cosTetMaxNuc
-  	 << " ctmax= " << costm
-  	 << " Z= " << targetZ << " A= " << targetA
+  	 << " 1-ctmaxN= " << 1. - cosTetMinNuc
+  	 << " 1-ctmax= " << 1. - costm
+  	 << " Z= " << targetZ 
   	 << G4endl;
   */
+
   if(costm >= cosTetMinNuc) return 2.0; 
 
@@ -343,6 +365,11 @@
   } while ( G4UniformRand() > grej*grej );  
 
-  //G4cout << "z= " << z1 << " cross= " << nucXSection/barn 
-  // << " crossE= " << elecXSection/barn << G4endl;
+  if(mass > MeV) {
+    if(G4UniformRand() > (1. - z1*0.5)/(1.0 + z1*sqrt(mom2)/targetMass)) {
+      return 2.0;
+    }
+  }
+  //G4cout << "z1= " << z1 << " cross= " << nucXSection/barn 
+  //	 << " crossE= " << elecXSection/barn << G4endl;
 
   return 1.0 - z1;
Index: trunk/source/processes/electromagnetic/standard/src/G4eIonisation.cc
===================================================================
--- trunk/source/processes/electromagnetic/standard/src/G4eIonisation.cc	(revision 1058)
+++ trunk/source/processes/electromagnetic/standard/src/G4eIonisation.cc	(revision 1196)
@@ -25,5 +25,5 @@
 //
 // $Id: G4eIonisation.cc,v 1.57 2009/02/20 12:06:37 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 // -------------------------------------------------------------------
